Index: /anuga_core/source/anuga/utilities/log_test.py
===================================================================
--- /anuga_core/source/anuga/utilities/log_test.py	(revision 6901)
+++ /anuga_core/source/anuga/utilities/log_test.py	(revision 6902)
@@ -31,5 +31,4 @@
         if os.path.exists(STDOUT_LOG_NAME):
             os.remove(STDOUT_LOG_NAME)
-        pass
 
     ##
Index: /branches/numpy/anuga/abstract_2d_finite_volumes/domain.py
===================================================================
--- /branches/numpy/anuga/abstract_2d_finite_volumes/domain.py	(revision 6901)
+++ /branches/numpy/anuga/abstract_2d_finite_volumes/domain.py	(revision 6902)
@@ -92,4 +92,7 @@
         """
 
+        number_of_full_nodes=None
+        number_of_full_triangles=None
+        
         # Determine whether source is a mesh filename or coordinates
         if type(source) == types.StringType:
@@ -117,4 +120,5 @@
 
         # Expose Mesh attributes (FIXME: Maybe turn into methods)
+        self.triangles = self.mesh.triangles        
         self.centroid_coordinates = self.mesh.centroid_coordinates
         self.vertex_coordinates = self.mesh.vertex_coordinates
@@ -205,6 +209,7 @@
         # the ghost triangles.
         if not num.allclose(self.tri_full_flag[:self.number_of_full_nodes], 1):
-            print ('WARNING:  '
-                   'Not all full triangles are store before ghost triangles')
+            if self.numproc>1:
+                print ('WARNING:  '
+                       'Not all full triangles are store before ghost triangles')
 
         # Defaults
@@ -306,4 +311,6 @@
     def get_normal(self, *args, **kwargs):
         return self.mesh.get_normal(*args, **kwargs)
+    def get_triangle_containing_point(self, *args, **kwargs):
+        return self.mesh.get_triangle_containing_point(*args, **kwargs)
 
     def get_intersecting_segments(self, *args, **kwargs):
@@ -1745,8 +1752,28 @@
 
     ##
-    # @brief ??
+    # @brief Sequential update of ghost cells 
     def update_ghosts(self):
-        pass
-
+        # We must send the information from the full cells and
+        # receive the information for the ghost cells
+        # We have a list with ghosts expecting updates
+
+        from Numeric import take,put
+
+
+        #Update of ghost cells
+        iproc = self.processor
+        if self.full_send_dict.has_key(iproc):
+
+            # now store full as local id, global id, value
+            Idf  = self.full_send_dict[iproc][0]
+
+            # now store ghost as local id, global id, value
+            Idg = self.ghost_recv_dict[iproc][0]
+
+            for i, q in enumerate(self.conserved_quantities):
+                Q_cv =  self.quantities[q].centroid_values
+                put(Q_cv,     Idg, take(Q_cv,     Idf))
+
+ 
     ##
     # @brief Extrapolate conserved quantities from centroid to vertices
Index: /branches/numpy/anuga/abstract_2d_finite_volumes/generic_boundary_conditions.py
===================================================================
--- /branches/numpy/anuga/abstract_2d_finite_volumes/generic_boundary_conditions.py	(revision 6901)
+++ /branches/numpy/anuga/abstract_2d_finite_volumes/generic_boundary_conditions.py	(revision 6902)
@@ -82,6 +82,15 @@
     """Time dependent boundary returns values for the
     conserved quantities as a function of time.
-    Must specify domain to get access to model time and a function f(t)
-    which must return conserved quantities as a function time
+    Must specify domain to get access to model time and a function of t
+    which must return conserved quantities as a function time.
+    
+    Example:
+      B = Time_boundary(domain, 
+                        function=lambda t: [(60<t<3660)*2, 0, 0])
+      
+      This will produce a boundary condition with is a 2m high square wave
+      starting 60 seconds into the simulation and lasting one hour.
+      Momentum applied will be 0 at all times.
+                        
     """
 
@@ -98,4 +107,16 @@
         self.verbose = verbose
 
+        
+        # FIXME: Temporary code to deal with both f and function
+        if function is not None and f is not None:
+            raise Exception, 'Specify either function or f to Time_boundary'
+            
+        if function is None and f is None:
+            raise Exception, 'You must specify a function to Time_boundary'
+            
+        if f is None:
+            f = function
+        #####
+        
         try:
             q = f(0.0)
Index: /branches/numpy/anuga/abstract_2d_finite_volumes/mesh_factory.py
===================================================================
--- /branches/numpy/anuga/abstract_2d_finite_volumes/mesh_factory.py	(revision 6901)
+++ /branches/numpy/anuga/abstract_2d_finite_volumes/mesh_factory.py	(revision 6902)
@@ -201,4 +201,151 @@
 
     return points, elements, boundary
+
+
+def rectangular_periodic(m_g, n_g, len1_g=1.0, len2_g=1.0, origin_g = (0.0, 0.0)):
+
+
+    """Setup a rectangular grid of triangles
+    with m+1 by n+1 grid points
+    and side lengths len1, len2. If side lengths are omitted
+    the mesh defaults to the unit square, divided between all the
+    processors
+
+    len1: x direction (left to right)
+    len2: y direction (bottom to top)
+
+    """
+
+    processor = 0
+    numproc   = 1
+
+    
+    n = n_g
+    m_low  = -1
+    m_high = m_g +1
+
+    m = m_high - m_low
+
+    delta1 = float(len1_g)/m_g
+    delta2 = float(len2_g)/n_g
+
+    len1 = len1_g*float(m)/float(m_g)
+    len2 = len2_g
+    origin = ( origin_g[0]+float(m_low)/float(m_g)*len1_g, origin_g[1] )
+
+    #Calculate number of points
+    Np = (m+1)*(n+1)
+
+    class VIndex:
+
+        def __init__(self, n,m):
+            self.n = n
+            self.m = m
+
+        def __call__(self, i,j):
+            return j+i*(self.n+1)
+
+    class EIndex:
+
+        def __init__(self, n,m):
+            self.n = n
+            self.m = m
+
+        def __call__(self, i,j):
+            return 2*(j+i*self.n)
+
+
+    I = VIndex(n,m)
+    E = EIndex(n,m)
+
+    points = num.zeros( (Np,2), num.Float)
+
+    for i in range(m+1):
+        for j in range(n+1):
+
+            points[I(i,j),:] = [i*delta1 + origin[0], j*delta2 + origin[1]]
+
+    #Construct 2 triangles per rectangular element and assign tags to boundary
+    #Calculate number of triangles
+    Nt = 2*m*n
+
+
+    elements = num.zeros( (Nt,3), num.Int)
+    boundary = {}
+    Idgl = []
+    Idfl = []
+    Idgr = []
+    Idfr = []
+
+    full_send_dict = {}
+    ghost_recv_dict = {}
+    nt = -1
+    for i in range(m):
+        for j in range(n):
+
+            i1 = I(i,j+1)
+            i2 = I(i,j)
+            i3 = I(i+1,j+1)
+            i4 = I(i+1,j)
+
+            #Lower Element
+            nt = E(i,j)
+            if i == 0:
+                Idgl.append(nt)
+
+            if i == 1:
+                Idfl.append(nt)
+
+            if i == m-2:
+                Idfr.append(nt)
+
+            if i == m-1:
+                Idgr.append(nt)
+
+            if i == m-1:
+                if processor == numproc-1:
+                    boundary[nt, 2] = 'right'
+                else:
+                    boundary[nt, 2] = 'ghost'
+        
+            if j == 0:
+                boundary[nt, 1] = 'bottom'
+            elements[nt,:] = [i4,i3,i2]
+
+            #Upper Element
+            nt = E(i,j)+1
+            if i == 0:
+                Idgl.append(nt)
+
+            if i == 1:
+                Idfl.append(nt)
+
+            if i == m-2:
+                Idfr.append(nt)
+
+            if i == m-1:
+                Idgr.append(nt)
+
+            if i == 0:
+                if processor == 0:
+                    boundary[nt, 2] = 'left'
+                else:
+                    boundary[nt, 2] = 'ghost'
+            if j == n-1:
+                boundary[nt, 1] = 'top'
+            elements[nt,:] = [i1,i2,i3]
+
+    Idfl.extend(Idfr)
+    Idgr.extend(Idgl)
+
+    Idfl = num.array(Idfl, num.Int)
+    Idgr = num.array(Idgr, num.Int)
+    
+    full_send_dict[processor]  = [Idfl, Idfl]
+    ghost_recv_dict[processor] = [Idgr, Idgr]
+
+
+    return  points, elements, boundary, full_send_dict, ghost_recv_dict
+
 
 def oblique(m, n, lenx = 1.0, leny = 1.0, theta = 8.95, origin = (0.0, 0.0)):
Index: /branches/numpy/anuga/abstract_2d_finite_volumes/quantity.py
===================================================================
--- /branches/numpy/anuga/abstract_2d_finite_volumes/quantity.py	(revision 6901)
+++ /branches/numpy/anuga/abstract_2d_finite_volumes/quantity.py	(revision 6902)
@@ -1178,4 +1178,5 @@
         # Edges have already been deprecated in set_values, see changeset:5521,
         # but *might* be useful in get_values. Any thoughts anyone?
+        # YES (Ole): Edge values are necessary for volumetric balance check
 
         if location not in ['vertices', 'centroids',
Index: /branches/numpy/anuga/abstract_2d_finite_volumes/test_domain.py
===================================================================
--- /branches/numpy/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 6901)
+++ /branches/numpy/anuga/abstract_2d_finite_volumes/test_domain.py	(revision 6902)
@@ -397,5 +397,5 @@
                                       
     def test_setting_timestepping_method(self):
-        """test_set_quanitities_to_be_monitored
+        """test_setting_timestepping_method
         """
 
@@ -803,4 +803,72 @@
                              [ 11.0,  11.0,  11.0]])
                              
+    def test_rectangular_periodic_and_ghosts(self):
+
+        from mesh_factory import rectangular_periodic
+        
+
+        M=5
+        N=2
+        points, vertices, boundary, full_send_dict, ghost_recv_dict = rectangular_periodic(M, N)
+
+        assert num.allclose(ghost_recv_dict[0][0], [24, 25, 26, 27,  0,  1,  2,  3])
+        assert num.allclose(full_send_dict[0][0] , [ 4,  5,  6,  7, 20, 21, 22, 23])
+
+        #print 'HERE'
+        
+        conserved_quantities = ['quant1', 'quant2']
+        domain = Domain(points, vertices, boundary, conserved_quantities,
+                        full_send_dict=full_send_dict,
+                        ghost_recv_dict=ghost_recv_dict)
+
+
+
+
+        assert num.allclose(ghost_recv_dict[0][0], [24, 25, 26, 27,  0,  1,  2,  3])
+        assert num.allclose(full_send_dict[0][0] , [ 4,  5,  6,  7, 20, 21, 22, 23])
+
+        def xylocation(x,y):
+            return 15*x + 9*y
+
+        
+        domain.set_quantity('quant1',xylocation,location='centroids')
+        domain.set_quantity('quant2',xylocation,location='centroids')
+
+
+        assert num.allclose(domain.quantities['quant1'].centroid_values,
+                            [  0.5,   1.,   5.,    5.5,   3.5,   4.,    8.,    8.5,   6.5,  7.,   11.,   11.5,   9.5,
+                               10.,   14.,   14.5,  12.5,  13.,   17.,   17.5,  15.5,  16.,   20.,   20.5,
+                               18.5,  19.,   23.,   23.5])
+
+
+
+        assert num.allclose(domain.quantities['quant2'].centroid_values,
+                            [  0.5,   1.,   5.,    5.5,   3.5,   4.,    8.,    8.5,   6.5,  7.,   11.,   11.5,   9.5,
+                               10.,   14.,   14.5,  12.5,  13.,   17.,   17.5,  15.5,  16.,   20.,   20.5,
+                               18.5,  19.,   23.,   23.5])
+
+        domain.update_ghosts()
+
+
+        assert num.allclose(domain.quantities['quant1'].centroid_values,
+                            [  15.5,  16.,   20.,   20.5,   3.5,   4.,    8.,    8.5,   6.5,  7.,   11.,   11.5,   9.5,
+                               10.,   14.,   14.5,  12.5,  13.,   17.,   17.5,  15.5,  16.,   20.,   20.5,
+                                3.5,   4.,    8.,    8.5])
+
+
+
+        assert num.allclose(domain.quantities['quant2'].centroid_values,
+                            [  15.5,  16.,   20.,   20.5,   3.5,   4.,    8.,    8.5,   6.5,  7.,   11.,   11.5,   9.5,
+                               10.,   14.,   14.5,  12.5,  13.,   17.,   17.5,  15.5,  16.,   20.,   20.5,
+                                3.5,   4.,    8.,    8.5])
+
+        
+        assert num.allclose(domain.tri_full_flag, [0, 0, 0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
+                                                   1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0])
+
+        #Test that points are arranged in a counter clock wise order
+        domain.check_integrity()
+
+
     def test_that_mesh_methods_exist(self):
         """test_that_mesh_methods_exist
@@ -828,4 +896,5 @@
         domain.get_number_of_nodes()
         domain.get_normal(0,0)
+        domain.get_triangle_containing_point([0.4,0.5])
         domain.get_intersecting_segments([[0.0, 0.0], [0.0, 1.0]])
         domain.get_disconnected_triangles()
Index: /branches/numpy/anuga/culvert_flows/test_culvert_routines.py
===================================================================
--- /branches/numpy/anuga/culvert_flows/test_culvert_routines.py	(revision 6901)
+++ /branches/numpy/anuga/culvert_flows/test_culvert_routines.py	(revision 6902)
@@ -19,11 +19,11 @@
 
 
-    def test_boyd_1(self):
-        """test_boyd_1
-        
-        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
-        """
-        # FIXME(Ole): This test fails (20 Feb 2009)
-
+    def test_boyd_0(self):
+        """test_boyd_0
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski
+        This test is the only one that passed in late February 2009
+        """
+      
         g=9.81
         culvert_slope=0.1  # Downward
@@ -67,6 +67,6 @@
         
 
-    def test_boyd_2(self):
-        """test_boyd_2
+    def Xtest_boyd_00(self):
+        """test_boyd_00
         
         This tests the Boyd routine with data obtained from ??? by Petar Milevski    
@@ -108,8 +108,461 @@
         
         #print Q, v, d
-        #assert num.allclose(Q, 0.185, rtol=1.0e-3)
+        assert num.allclose(Q, 0.185, rtol=1.0e-3)
         #assert num.allclose(v, 0.93)
         #assert num.allclose(d, 0.0)
         
+    def Xtest_boyd_1(self):
+        """test_boyd_1
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=0.263
+        outlet_depth=0.0
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 0.10, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 1.13, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.15, rtol=1.0e-2) #depth at outlet used to calc v 
+        
+    def Xtest_boyd_2(self):
+        """test_boyd_2
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=1.135
+        outlet_depth=0.0
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 1.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 2.59, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.563, rtol=1.0e-2) #depth at outlet used to calc v  
+
+    def Xtest_boyd_3(self):
+        """test_boyd_3
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=12.747
+        outlet_depth=0.0
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 5.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 11.022, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.72, rtol=1.0e-2) #depth at outlet used to calc v
+
+    def Xtest_boyd_4(self):
+        """test_boyd_4
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=1.004
+        outlet_depth=1.00
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 0.10, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 0.22, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
+
+    def Xtest_boyd_5(self):
+        """test_boyd_5
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=1.401
+        outlet_depth=1.00
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 1.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 2.204, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
+
+
+    def Xtest_boyd_6(self):
+        """test_boyd_5
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.01  # Downward
+
+        inlet_depth=12.747
+        outlet_depth=1.00
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 5.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 11.022, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
+
+
+    def Xtest_boyd_7(self):
+        """test_boyd_7
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.1  # Downward
+
+        inlet_depth=0.303
+        outlet_depth=0.00
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 0.10, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 1.13, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.19, rtol=1.0e-2) #depth at outlet used to calc v
+
+
+    def Xtest_boyd_8(self):
+        """test_boyd_8
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.1  # Downward
+
+        inlet_depth=1.135
+        outlet_depth=0.00
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 1.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 2.204, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
+
+    def Xtest_boyd_9(self):
+        """test_boyd_9
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.1  # Downward
+
+        inlet_depth=1.1504
+        outlet_depth=1.5
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 0.10, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 0.22, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
+
+
+    def Xtest_boyd_10(self):
+        """test_boyd_9
+        
+        This tests the Boyd routine with data obtained from ??? by Petar Milevski    
+        """
+        # FIXME(Ole): This test fails (20 Feb 2009)
+
+        g=9.81
+        culvert_slope=0.1  # Downward
+
+        inlet_depth=1.901
+        outlet_depth=1.5
+
+        culvert_length=4.0
+        culvert_width=0.75
+        culvert_height=0.75
+        
+        culvert_type='pipe'
+        manning=0.013
+        sum_loss=1.5
+
+        inlet_specific_energy=inlet_depth #+0.5*v**2/g 
+        z_in = 0.0
+        z_out = -culvert_length*culvert_slope/100
+        E_in = z_in+inlet_depth  #+ 0.5*v**2/g
+        E_out = z_out+outlet_depth  #+ 0.5*v**2/g
+        delta_total_energy = E_in-E_out
+
+        Q, v, d = boyd_generalised_culvert_model(inlet_depth, 
+                                                 outlet_depth,
+                                                 inlet_specific_energy, 
+                                                 delta_total_energy, 
+                                                 g,
+                                                 culvert_length,
+                                                 culvert_width,
+                                                 culvert_height,
+                                                 culvert_type,
+                                                 manning,
+                                                 sum_loss)
+        
+        print Q, v, d
+        assert num.allclose(Q, 1.00, rtol=1.0e-2) #inflow
+        assert num.allclose(v, 2.204, rtol=1.0e-2) #outflow velocity
+        assert num.allclose(d, 0.76, rtol=1.0e-2) #depth at outlet used to calc v
     
                
